# Load the data
wisc<-read.table("C:/Users/kjgrimm/Documents/UCD/Organization/Workshops/ATI/APA-ATI LSEM 2015/Session C - Lab - Intro Longitudinal/Session C - Progamming Scripts/wisc3raw.dat")

names(wisc) = c('id','verb1','verb2','verb4','verb6','perfo1','perfo2','perfo4','perfo6',
'info1','comp1','simu1','voca1','info6','comp6','simu6','voca6','momed','grad','constant')

head(wisc)

# Transform to long-format data structure
wisc_long = reshape(wisc, idvar='id', varying=c('verb1','perfo1','verb2','perfo2','verb4','perfo4','verb6','perfo6'),
times = c(1,2,4,6),
v.names = c('x','y'), direction='long')

wisc_long = wisc_long[order(wisc_long$id, wisc_long$time), ]
wisc_long$verb = wisc_long$x
wisc_long$perf = wisc_long$y


head(wisc_long)


# Save the transformed data into a file
write.table(wis_long, "C:/Users/kmarcoul/Dropbox/ASU/APA Workshop/Session C_Programs/wiscRtran2.dat",
		row.names = FALSE)    


#transforming from long-form data to wide-form data
# Reshape back to wide

wisc_wide = reshape(wisc_long, v.names=c('verb','perf'), idvar='id', timevar='time', direction='wide')

head(wisc_wide)



## Using Wide Daaset

wisc_vars = wisc_wide[ , c('id','verb.1', 'verb.2', 'verb.4', 'verb.6', 
                                'perf.1', 'perf.2', 'perf.4', 'perf.6',
                                'momed','grad')]

mean(wisc_vars$perf.1)
mean(wisc_vars$perf.2)
mean(wisc_vars$perf.4)
mean(wisc_vars$perf.6)

## Bivariate Descriptives
cor(wisc_vars, use='pairwise.complete.obs')
cov(wisc_vars, use='pairwise.complete.obs')


## Plotting ##

##install.packages('ggplot2')
library(ggplot2)

plot_obs <- ggplot(data=wisc_long, aes(x=time, y=perf, group=id)) +
                 geom_line() +
                 theme_bw() +
                 scale_x_continuous(breaks = c(1,2,3,4,5,6), name = "Grade") + 
                 scale_y_continuous(breaks = c(0, 20, 40, 60, 80), name = "Performance Score")

print(plot_obs)


# Plot the data
interaction.plot(wisc_long$time,wisc_long$id,wisc_long$perf,xlab='Occasion',ylab='Performance score',legend=F)



    