*Reading in *.dat ASCII Datafile.

GET DATA  /TYPE=TXT
  /FILE="C:\Users\kjgrimm\Documents\UCD\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session C - Lab - Intro Longitudinal\Session C - Progamming Scripts\wisc3raw.dat"
  /FIXCASE=1
  /ARRANGEMENT=FIXED
  /FIRSTCASE=1
  /IMPORTCASE=ALL
  /VARIABLES=
  /1 id 0-9 F10.3
  verb1 10-19 F10.3
  verb2 20-29 F10.3
  verb4 30-39 F10.3
  verb6 40-49 F10.3
  perfo1 50-59 F10.3
  perfo2 60-69 F10.3
  perfo4 70-79 F10.3
  perfo6 80-89 F10.3
  info1 90-99 F10.3
  comp1 100-109 F10.3
  simi1 110-119 F10.3
  voca1 120-129 F10.3
  info6 130-139 F10.3
  comp6 140-149 F10.3
  simi6 150-159 F10.3
  voca6 160-169 F10.3
  momed 170-179 F10.3
  grad 180-189 F10.3
  constant 190-199 F10.3.
CACHE.
EXECUTE.
DATASET NAME DataSet1 WINDOW=FRONT.


*Correlations over time.
CORRELATIONS
  /VARIABLES=perfo1 perfo2 perfo4 perfo6
  /MISSING=PAIRWISE .

*Means over time.

DESCRIPTIVES
  VARIABLES=perfo1 perfo2 perfo4 perfo6
  /STATISTICS=MEAN STDDEV MIN MAX .

*Restructure data from wide to long.
VARSTOCASES
  /MAKE verb FROM verb1 verb2 verb4 verb6
  /MAKE perfo FROM perfo1 perfo2 perfo4 perfo6
  /INDEX=occasion(4) 
  /KEEP=id momed grad constant
  /NULL=KEEP.

if (occasion=1) grade = 1.
if (occasion=2) grade = 2.
if (occasion=3) grade = 4.
if (occasion=4) grade = 6.
EXECUTE.



*Longitudinal Plot.
igraph
/x1=var(grade) type = scale
/y=var(perfo) type=scale
/style=var(id)
/line(mode) key=off style=line interpolate=straight
/scalerange=var(verb) min=0 max=100.


GGRAPH 
  /GRAPHDATASET NAME="iGraphDataset" VARIABLES= perfo grade id 
  /GRAPHSPEC SOURCE=INLINE . 
BEGIN GPL 
SOURCE: s=userSource( id( "iGraphDataset" ) ) 
DATA: perfo=col( source(s), name( "perfo" ) ) 
DATA: grade=col( source(s), name( "grade" ) ) 
DATA: id=col( source(s), name( "id" ), unit.category() ) 
GUIDE: text.title( label( "Performance Longitudinal Plot" ) ) 
GUIDE: axis( dim( 1 ), label( "Grade" ) ) 
GUIDE: axis( dim( 2 ), label( "WISC Performance" ) ) 
GUIDE: legend( aesthetic( aesthetic.shape.interior ), null() ) 
SCALE: linear( dim( 1 ), min( 1 ), max( 6 ) ) 
SCALE: linear( dim( 2 ), min( 0 ), max( 100 ) ) 
ELEMENT: point( position( grade * perfo ) )
ELEMENT: line( position( grade * perfo ) ), shape.interior( id )) 
END GPL.




*Transform data file from long to wide.
SORT CASES BY id grade.
CASESTOVARS
  /ID = id
  /FIXED = momed grad constant
  /INDEX grade
  /GROUPBY = VARIABLE.

*Outputting a dat file for Mplus, LisReL, etc.
WRITE OUTFILE='D:\Workshops\APA_2015\Section C_SEM\wisc3raw_out.dat'
  TABLE
  /id verb.1.00 verb.2.00 verb.4.00 verb.6.00 perfo.1.00 perfo.2.00 perfo.4.00 perfo.6.00 momed grad  .
EXECUTE.




GET DATA  /TYPE=TXT
  /FILE="C:\Users\kjgrimm\Documents\UCD\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session C - Lab - Intro Longitudinal\Session C - Progamming Scripts\wisc3raw.dat"
  /ENCODING='Locale'
  /FIXCASE=1
  /ARRANGEMENT=FIXED
  /FIRSTCASE=1
  /IMPORTCASE=ALL
  /VARIABLES=
  /1 V1 0-9 F10.3
  V2 10-19 F10.3
  V3 20-29 F10.3
  V4 30-39 F10.3
  V5 40-49 F10.3
  V6 50-59 F10.3
  V7 60-69 F10.3
  V8 70-79 F10.3
  V9 80-89 F10.3
  V10 90-99 F10.3
  V11 100-109 F10.3
  V12 110-119 F10.3
  V13 120-129 F10.3
  V14 130-139 F10.3
  V15 140-149 F10.3
  V16 150-159 F10.3
  V17 160-169 F10.3
  V18 170-179 F10.3
  V19 180-189 F10.3
  V20 190-199 F10.3.
CACHE.
EXECUTE.
DATASET NAME DataSet1 WINDOW=FRONT.
