
*Inputing data file;
DATA wiscraw;
	INFILE 'D:\Workshops\APA_2015\Session C_SEM_Lab\Session C_Programs\wisc3raw.dat';
	INPUT id
    	  verb1 verb2 verb4 verb6 perfo1 perfo2 perfo4 perfo6
    	  info1 comp1 simu1 voca1 info6 comp6 simu6 voca6 momed grad constant;
RUN;

*Converting wide format data (single-record) to long format (multiple-record);
DATA wisc_long;
	SET wiscraw;
	id = id; time=1; verb=verb1; perfo=perfo1; OUTPUT;
	id = id; time=2; verb=verb2; perfo=perfo2; OUTPUT;
	id = id; time=4; verb=verb4; perfo=perfo4; OUTPUT;
	id = id; time=6; verb=verb6; perfo=perfo6; OUTPUT;
	KEEP id time verb perfo momed grad;
RUN;

PROC PRINT DATA = wisc_long; RUN;


*Examining Correlations Across Time;
PROC CORR DATA=wiscraw;
	VAR perfo1 perfo2 perfo4 perfo6;
RUN;

*Examining Means Across Time;
PROC MEANS DATA=wiscraw;
	VAR perfo1 perfo2 perfo4 perfo6;
RUN;

/**** ------------- Longitudinal Plots -------------- ***/
/********************************************************/
*Standard intraindivual change;
GOPTIONS RESET=ALL;
GOPTIONS FTEXT=swiss CTEXT=black HTEXT=1 FTITLE=SWISSX HTITLE=2.0;
PROC GPLOT DATA=wiscrawlong;
	TITLE ' ';
	SYMBOL1 REPEAT=500 I=join V=dot H=.5 W=.5 C=blue; *interpol=spline value=circle;
	AXIS1
		ORDER = (0 to 100 by 10)
		LABEL = (A=90 F=SWISSX h=1.3 'WISC Performance Score')
		MINOR = none
		OFFSET = (2);
	AXIS2
		ORDER = (1 to 6 by 1)
		LABEL = (F=SWISSX H=1.3 'Grade')
		MINOR = none
		OFFSET = (2); 
	PLOT perfo * time = id /NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2;
RUN;
QUIT;
