data wisc;
infile 'c:\wisc3raw.dat';
input id verb1 verb2 verb4 verb6 perfo1 perfo2 perfo4 perfo6
	info1 comp1 simi1 voca1 info6 comp6 simi6 voca6 momed grad constant;
run;

/* stack repeated measures data */

data wiscstacked;
set wisc;
years = 0; perform = perfo1; output;
years = 1; perform = perfo2; output;
years = 3; perform = perfo4; output;
years = 5; perform = perfo6; output;
keep id grad years perform;
run;

/* ex1: intercept-only model */

proc mixed data = wiscstacked noclprint covtest;
class id;
model perform =  / solution;
random intercept / subject = id type = un;
run;

/* ex2: linear growth model */

proc mixed data = wiscstacked noclprint covtest;
class id;
model perform = years / solution;
random intercept years / subject = id type = un;
run;

/* ex3: quadratic growth model */

proc mixed data = wiscstacked noclprint covtest;
class id;
model perform = years years*years / solution;
random intercept years / subject = id type = un;
run;
