################################################################################
# Title: V subtests: Null model
# File: Session L - Computer Programs/prog00_vc_0fac.R
# Source File: Session L - Computer Programs/prog00_vc_0fac.out
# Created: Tue Jun 21 00:15:18 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VModel <- mxModel("V subtests_ Null model",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_06', 'voca_06', 'comp_06', 'simi_06'),
    latentVars='vc_06',
    # specify 'BY' parameter(s)
    mxPath(from='vc_06', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to='vc_06', arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(19.776, 20.396, 21.797, 14.903), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'Variance' parameter(s)
    mxPath(from='vc_06', to='vc_06', arrows=2,
        free=FALSE, values=1, labels=NA),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=2,
        free=TRUE, values=c(37.261, 39.391, 94.434, 56.881), labels=c('p5', 'p6', 'p7', 'p8')))

# run model
VModelResults <- mxRun(VModel)

# view summary of results
summary(VModelResults)
