################################################################################
# Title: Gc-Gf: 0 Factor model - null model
# File: Session L - Computer Programs/prog10_gcgf_0fac.R
# Source File: Session L - Computer Programs/prog10_gcgf_0fac.out
# Created: Tue Jun 21 00:15:18 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'comp_06', 'voca_06', 'bloc_06', 'obje_06')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
Gc_Gf_Model <- mxModel("Gc_Gf_ 0 Factor model _ null model",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('comp_06', 'voca_06', 'bloc_06', 'obje_06'),
    latentVars='g_06',
    # specify 'BY' parameter(s)
    mxPath(from='g_06', to=c('comp_06', 'voca_06', 'bloc_06', 'obje_06'), arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to='g_06', arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('comp_06', 'voca_06', 'bloc_06', 'obje_06'), arrows=1,
        free=TRUE, values=c(21.797, 20.396,  6.942, 25.258), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'Variance' parameter(s)
    mxPath(from='g_06', to='g_06', arrows=2,
        free=FALSE, values=1, labels=NA),
    # specify 'Variance' parameter(s)
    mxPath(from=c('comp_06', 'voca_06', 'bloc_06', 'obje_06'), to=c('comp_06', 'voca_06', 'bloc_06', 'obje_06'), arrows=2,
        free=TRUE, values=c( 94.431,  39.389,  43.333, 267.463), labels=c('p5', 'p6', 'p7', 'p8')))

# run model
Gc_Gf_ModelResults <- mxRun(Gc_Gf_Model)

# view summary of results
summary(Gc_Gf_ModelResults)
