################################################################################
# Title: Verbal factor at Ages 6 and 11 Years Configural Invariance with unique covariances
# File: Session L - Computer Programs/prog20a_1fac2times_config_uniq_covs.R
# Source File: Session L - Computer Programs/prog20a_1fac2times_config_uniq_covs.out
# Created: Tue Jun 21 00:15:19 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
# Some parameters were constrained to equality based on Mplus output;
#    please check that this constraint is correct.
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VerbalModel <- mxModel("Verbal factor at Ages 6 and 11 Years Configural Invariance with unique covariances",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'info_06', 'voca_06', 'comp_06', 'simi_06'),
    latentVars=c('verb_06', 'verb_11'),
    # specify 'BY' parameter(s)
    mxPath(from='verb_06', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(4.470, 5.000, 6.868, 4.636), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'BY' parameter(s)
    mxPath(from='verb_11', to=c('info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=1,
        free=TRUE, values=c(4.470, 4.090, 4.026, 4.564), labels=c('p1', 'p5', 'p6', 'p7')),
    # specify 'WITH' parameter(s)
    mxPath(from='verb_06', to='verb_11', arrows=2,
        free=TRUE, values=1.817, labels='p8'),
    # specify 'WITH' parameter(s)
    mxPath(from='info_11', to='info_06', arrows=2,
        free=TRUE, values=0.979, labels='p9'),
    # specify 'WITH' parameter(s)
    mxPath(from='voca_11', to='voca_06', arrows=2,
        free=TRUE, values=1.741, labels='p10'),
    # specify 'WITH' parameter(s)
    mxPath(from='comp_11', to='comp_06', arrows=2,
        free=TRUE, values=-0.217, labels='p11'),
    # specify 'WITH' parameter(s)
    mxPath(from='simi_11', to='simi_06', arrows=2,
        free=TRUE, values=-1.446, labels='p12'),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to=c('verb_06', 'verb_11'), arrows=1,
        free=c(FALSE,  TRUE), values=c(0.000, 6.429), labels=c(NA   , 'p13')),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=1,
        free=TRUE, values=c(19.776, 20.396, 21.797, 14.903, 19.776, 18.151, 19.294, 11.956), labels=c('p14', 'p15', 'p16', 'p17', 'p14', 'p18', 'p19', 'p20')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('verb_06', 'verb_11'), to=c('verb_06', 'verb_11'), arrows=2,
        free=c(FALSE,  TRUE), values=c(1.000, 5.797), labels=c(NA   , 'p21')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=2,
        free=TRUE, values=c(17.293, 14.374, 47.246, 35.454, 46.956, 23.859, 73.488, 88.773), labels=c('p22', 'p23', 'p24', 'p25', 'p26', 'p27', 'p28', 'p29')))

# run model
VerbalModelResults <- mxRun(VerbalModel)

# view summary of results
summary(VerbalModelResults)
