################################################################################
# Title: Verbal factor at Ages 6 and 11 Years STRICT Factorial Invariance with unique covariances
# File: Session L - Computer Programs/prog23a_1fac2times_strict_fi_uniq_covs.R
# Source File: Session L - Computer Programs/prog23a_1fac2times_strict_fi_uniq_covs.out
# Created: Tue Jun 21 00:15:19 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
# Some parameters were constrained to equality based on Mplus output;
#    please check that this constraint is correct.
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VerbalModel <- mxModel("Verbal factor at Ages 6 and 11 Years STRICT Factorial Invariance with unique covariances",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'info_06', 'voca_06', 'comp_06', 'simi_06'),
    latentVars=c('verb_06', 'verb_11'),
    # specify 'BY' parameter(s)
    mxPath(from='verb_06', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(5.248, 4.495, 4.523, 5.040), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'BY' parameter(s)
    mxPath(from='verb_11', to=c('info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=1,
        free=TRUE, values=c(5.248, 4.495, 4.523, 5.040), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'WITH' parameter(s)
    mxPath(from='verb_06', to='verb_11', arrows=2,
        free=TRUE, values=1.622, labels='p5'),
    # specify 'WITH' parameter(s)
    mxPath(from='info_11', to='info_06', arrows=2,
        free=TRUE, values=0.548, labels='p6'),
    # specify 'WITH' parameter(s)
    mxPath(from='voca_11', to='voca_06', arrows=2,
        free=TRUE, values=5.891, labels='p7'),
    # specify 'WITH' parameter(s)
    mxPath(from='comp_11', to='comp_06', arrows=2,
        free=TRUE, values=0.002, labels='p8'),
    # specify 'WITH' parameter(s)
    mxPath(from='simi_11', to='simi_06', arrows=2,
        free=TRUE, values=-2.785, labels='p9'),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to=c('verb_06', 'verb_11'), arrows=1,
        free=c(FALSE,  TRUE), values=c(0.000, 5.344), labels=c(NA   , 'p10')),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=1,
        free=TRUE, values=c(19.928, 20.402, 21.384, 14.635, 19.928, 20.402, 21.384, 14.635), labels=c('p11', 'p12', 'p13', 'p14', 'p11', 'p12', 'p13', 'p14')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('verb_06', 'verb_11'), to=c('verb_06', 'verb_11'), arrows=2,
        free=c(FALSE,  TRUE), values=c(1.000, 4.581), labels=c(NA   , 'p15')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=2,
        free=TRUE, values=c(15.271, 16.602, 58.182, 53.209, 53.209, 53.209, 53.209, 53.209), labels=c('p16', 'p17', 'p18', 'p19', 'p19', 'p19', 'p19', 'p19')))

# run model
VerbalModelResults <- mxRun(VerbalModel)

# view summary of results
summary(VerbalModelResults)
