################################################################################
# Title: Verbal factor at Ages 6 and 11 Years single factor
# File: Session L - Computer Programs/prog25_1fac2times_1factor.R
# Source File: Session L - Computer Programs/prog25_1fac2times_1factor.out
# Created: Tue Jun 21 00:15:19 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
# Some parameters were constrained to equality based on Mplus output;
#    please check that this constraint is correct.
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VerbalModel <- mxModel("Verbal factor at Ages 6 and 11 Years single factor",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'info_06', 'voca_06', 'comp_06', 'simi_06'),
    latentVars='verb_06',
    # specify 'BY' parameter(s)
    mxPath(from='verb_06', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(4.698, 4.761, 7.083, 4.891), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_06'), arrows=1,
        free=c( TRUE,  TRUE,  TRUE,  TRUE, FALSE), values=c(20.929, 44.446, 45.174, 41.297,  0.000), labels=c('p5', 'p6', 'p7', 'p8', NA  )),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(20.929, 21.064, 22.791, 15.590), labels=c('p5' , 'p9' , 'p10', 'p11')),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_06'), to=c('info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_06'), arrows=2,
        free=c( TRUE,  TRUE,  TRUE,  TRUE, FALSE), values=c(923.393, 121.423, 167.464, 209.739,   1.000), labels=c('p12', 'p13', 'p14', 'p15', NA   )),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=2,
        free=TRUE, values=c(16.520, 17.167, 45.257, 33.426), labels=c('p16', 'p17', 'p18', 'p19')))

# run model
VerbalModelResults <- mxRun(VerbalModel)

# view summary of results
summary(VerbalModelResults)
