################################################################################
# Title: Verbal factor at Ages 6 and 11 Years STRONG Factorial Invariance Latent Change at Latent Level
# File: Session L - Computer Programs/prog31_1fac2times_strong_fi_latent_change.R
# Source File: Session L - Computer Programs/prog31_1fac2times_strong_fi_latent_change.out
# Created: Tue Jun 21 00:15:20 2011
################################################################################
# TranslateOpenMx library (Version 0.1)
# Some parameters were constrained to equality based on Mplus output;
#    please check that this constraint is correct.
################################################################################

# load OpenMx
library(OpenMx)

# load data
rto8age2 <- read.table('rto8age2.dat', na.string="c('USEVAR' , '='      , 'info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11')")
names(rto8age2) <- c('id', 'moeducat', 'age_06', 'info_06', 'comp_06',
    'simi_06', 'voca_06', 'picc_06', 'pica_06', 'bloc_06',
    'obje_06', 'age_11', 'info_11', 'comp_11', 'simi_11',
    'voca_11', 'picc_11', 'pica_11', 'bloc_11', 'obje_11')

# specify model
VerbalModel <- mxModel("Verbal factor at Ages 6 and 11 Years STRONG Factorial Invariance Latent Change at Latent Level",
    type="RAM",
    # specify data and variables
    mxData(rto8age2, "raw"),
    manifestVars=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11'),
    latentVars=c('verb_06', 'verb_11', 'dver_11'),
    # specify 'BY' parameter(s)
    mxPath(from='verb_06', to=c('info_06', 'voca_06', 'comp_06', 'simi_06'), arrows=1,
        free=TRUE, values=c(5.269, 4.547, 4.525, 4.960), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'BY' parameter(s)
    mxPath(from='verb_11', to=c('info_11', 'voca_11', 'comp_11', 'simi_11'), arrows=1,
        free=TRUE, values=c(5.269, 4.547, 4.525, 4.960), labels=c('p1', 'p2', 'p3', 'p4')),
    # specify 'BY' parameter(s)
    mxPath(from='dver_11', to='verb_11', arrows=1,
        free=FALSE, values=1, labels=NA),
    # specify 'ON' parameter(s)
    mxPath(from='verb_06', to='verb_11', arrows=1,
        free=FALSE, values=1, labels=NA),
    # specify 'ON' parameter(s)
    mxPath(from='verb_06', to='dver_11', arrows=1,
        free=TRUE, values=0.608, labels='p5'),
    # specify 'WITH' parameter(s)
    mxPath(from=c('verb_06', 'dver_11'), to='verb_11', arrows=2,
        free=FALSE, values=0, labels=NA),
    # specify 'WITH' parameter(s)
    mxPath(from='dver_11', to='verb_06', arrows=2,
        free=FALSE, values=0, labels=NA),
    # specify 'Mean' parameter(s)
    mxPath(from='one', to='verb_06', arrows=1,
        free=FALSE, values=0, labels=NA),
    # specify 'Intercept' parameter(s)
    mxPath(from='one', to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_11', 'dver_11'), arrows=1,
        free=c( TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE, FALSE,  TRUE), values=c(19.929, 20.311, 21.459, 14.882, 19.929, 20.311, 21.459, 14.882,  0.000,  5.337), labels=c('p6' , 'p7' , 'p8' , 'p9' , 'p6' , 'p7' , 'p8' , 'p9' , NA   , 'p10')),
    # specify 'Variance' parameter(s)
    mxPath(from='verb_06', to='verb_06', arrows=2,
        free=FALSE, values=1, labels=NA),
    # specify 'Variance' parameter(s)
    mxPath(from=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_11', 'dver_11'), to=c('info_06', 'voca_06', 'comp_06', 'simi_06', 'info_11', 'voca_11', 'comp_11', 'simi_11', 'verb_11', 'dver_11'), arrows=2,
        free=c( TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE,  TRUE, FALSE,  TRUE), values=c(15.123, 16.339, 57.819, 34.209, 45.360, 24.586, 74.229, 89.573,  0.000,  1.971), labels=c('p11', 'p12', 'p13', 'p14', 'p15', 'p16', 'p17', 'p18', NA   , 'p19')))

# run model
VerbalModelResults <- mxRun(VerbalModel)

# view summary of results
summary(VerbalModelResults)
