*****************************************************
*		ATI workshop					            *
*		Session L    :                              *
*       rto8age2.dta                             	* 
*       Mplus file:    prog02_Vc_2fac              	*
*****************************************************

*TITLE:    V subtests: 2 Factor model
// Verbal information (Vc)
// Verbal reasoning   (Vr)
clear

* Read data - rto8age2.dat
cd "C:\Users\JiHoon\Documents\UVa_Tenure\Service\Advising\ATI_STATA_RyooShi\Week3_22Apr14\Session L - Lecture - Common Factors\Session_L_Programs\Stata" 
use "rto8age2.dta"

* Model
sem (Vc_06 -> info_06, ) (Vc_06@L2 -> voca_06, ) (Vr_06 -> comp_06, ) (Vr_06@L4 -> simi_06, ), ///
covstruct(_lexogenous, diagonal) iterate(10000) latent(Vc_06 Vr_06 ) cov( Vc_06@1 Vc_06*Vr_06 Vr_06@1) means( Vc_06@0 Vr_06@0) nocapslatent

* Standardized result
sem (Vc_06 -> info_06, ) (Vc_06@L2 -> voca_06, ) (Vr_06 -> comp_06, ) (Vr_06@L4 -> simi_06, ), ///
covstruct(_lexogenous, diagonal) iterate(10000) latent(Vc_06 Vr_06 ) cov( Vc_06@1 Vc_06*Vr_06 Vr_06@1) means( Vc_06@0 Vr_06@0) standardized nocapslatent

* Goodness of fit
estat gof, stats(all)
