ODS GRAPHICS OFF;
ODS HTML CLOSE;
ODS LISTING;

DATA wisc;
	INFILE 'C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session I - Lecture - Multiple Group Growth\Session I - Computer Scripts\Mplus - Multiple Group\wisc3raw.dat';
	INPUT id verb1 verb2 verb4 verb6 perfo1 perfo2 perfo4 perfo6
          info1 comp1 simi1 voca1 info6 comp6 simi6 voca6 
          momed grad constant;
RUN;

PROC MEANS;
	VAR perfo1 perfo2 perfo4 perfo6;
RUN;

*****************************************************************************
	Categorizing Performance Total Scores based on a total score of 35 
	         (Arbitrary - but based on distribution of scores)
	     This is simply to demonstrate models for categorical data
		   It's often not a good idea to categorize data 
			             You have been warned
*****************************************************************************;

DATA wisc_cat;
	SET wisc;
	IF perfo1 > 35 THEN perf_cat1 = 1; ELSE perf_cat1 = 0;
	IF perfo2 > 35 THEN perf_cat2 = 1; ELSE perf_cat2 = 0;
	IF perfo4 > 35 THEN perf_cat4 = 1; ELSE perf_cat4 = 0;
	IF perfo6 > 35 THEN perf_cat6 = 1; ELSE perf_cat6 = 0;
RUN;

PROC FREQ DATA = wisc_cat;
	TABLES perf_cat2 perf_cat4;
RUN;

PROC CORR DATA = wisc_cat;
	VAR perf_cat2 perf_cat4;
RUN;

PROC FREQ DATA = wisc_cat;
	TABLES perf_cat2*perf_cat4/CHISQ PLCORR;
RUN;

*Type A Model;
PROC LOGISTIC DATA = wisc_cat DESCENDING;
	MODEL perf_cat4 = perf_cat2/RSQ RISKLIMITS LINK = logit; *Could Use LINK=Probit;
RUN;


DATA wisc_cat_long;
	SET wisc_cat;
	grade = 2; perf_cat = perf_cat2; contrast = 0; OUTPUT;
	grade = 4; perf_cat = perf_cat4; contrast = 1; OUTPUT;
	KEEP id grade perf_cat contrast;
RUN;

*Type D Model;
PROC LOGISTIC DESCENDING DATA = wisc_cat_long;
	MODEL perf_cat = contrast/RSQ LINK=logit;
*Could use Link = probit;
RUN;
