library(lavaan)

#### Categorical Growth  ######

wisc3raw<-read.table("C:\\Users\\kjgrimm\\Documents\\UCD\\Organization\\Workshops\\ATI\\APA-ATI LSEM 2016\\Session O - Lab - Categorical Outcomes\\Session O - Programming Scripts\\lavaan\\Categorical Growth\\wisc3raw.dat",header=F)
names(wisc3raw)<-c("id","verb1","verb2","verb4","verb6",
			      "perfo1","perfo2","perfo4","perfo6",
                         "info1","comp1","simi1","voca1","info6","comp6",
				"simi6","voca6","momed","grad","constant")
#Define Varianbles

wisc3raw$perf_c1<-ifelse(wisc3raw$perfo1>35,1,0)
wisc3raw$perf_c2<-ifelse(wisc3raw$perfo2>35,1,0)
wisc3raw$perf_c4<-ifelse(wisc3raw$perfo4>35,1,0)
wisc3raw$perf_c6<-ifelse(wisc3raw$perfo6>35,1,0)


linear_wisc<-'

#Level and Growth
b_0n =~ 1*perf_c1+1*perf_c2+1*perf_c4+1*perf_c6
b_1n =~ 0*perf_c1+1*perf_c2+3*perf_c4+5*perf_c6
b_0n ~0*1
b_1n ~start(1.527)*1
b_0n~~start(1.988)*b_0n
b_1n~~start(.581)*b_1n
b_0n~~start(-.118)*b_1n

#Thresholds
perf_c1|tau*t1+start(2.961)*t1
perf_c2|tau*t1+start(2.961)*t1
perf_c4|tau*t1+start(2.961)*t1
perf_c6|tau*t1+start(2.961)*t1
   
perf_c1 ~~ 1*perf_c1            
perf_c2 ~~ 1*perf_c2            
perf_c4 ~~ 1*perf_c4            
perf_c6 ~~ 1*perf_c6
'

linear_wisc_fit<-cfa(linear_wisc,
data=wisc3raw,ordered=c("perf_c1","perf_c2","perf_c4","perf_c6"), parameterization='theta')

summary(linear_wisc_fit)

#lavaan (0.5-18) converged normally after  21 iterations
#
#  Number of observations                           204
#
#  Estimator                                       DWLS      Robust
#  Minimum Function Test Statistic               11.765      12.995
#  Degrees of freedom                                 5           5
#  P-value (Chi-square)                           0.038       0.023
#  Scaling correction factor                                  1.044
#  Shift parameter                                            1.725
#    for simple second-order correction (Mplus variant)
#
#Parameter estimates:
#
#  Information                                 Expected
#  Standard Errors                           Robust.sem
#
#                   Estimate  Std.err  Z-value  P(>|z|)
#Latent variables:
#  b_0n =~
#    perf_c1           1.000
#    perf_c2           1.000
#    perf_c4           1.000
#    perf_c6           1.000
#  b_1n =~
#    perf_c1           0.000
#    perf_c2           1.000
#    perf_c4           3.000
#    perf_c6           5.000
#
#Covariances:
#  b_0n ~~
#    b_1n              0.005    0.272    0.019    0.985
#
#Intercepts:
#    b_0n              0.000
#    b_1n              1.645    0.347    4.742    0.000
#    perf_c1           0.000
#    perf_c2           0.000
#    perf_c4           0.000
#    perf_c6           0.000
#
#Thresholds:
#    prf_1|1 (tau)     3.070    0.629    4.879    0.000
#    prf_2|1 (tau)     3.070    0.629    4.879    0.000
#    prf_4|1 (tau)     3.070    0.629    4.879    0.000
#    prf_6|1 (tau)     3.070    0.629    4.879    0.000
#
#Variances:
#    b_0n              1.871    1.306
#    b_1n              0.741    0.396
#    perf_c1           1.000
#    perf_c2           1.000
#    perf_c4           1.000
#    perf_c6           1.000
#
#Scales y*:
#    perf_c1           0.590
#    perf_c2           0.525
#    perf_c4           0.323
#    perf_c6           0.216

