brad_fluid_4156a<-read.table("brad_fluid_4156a.dat",header=F)
names(brad_fluid_4156a)<-c("ind_41","cod_41","freas_41","pap_41","reas_41",
  	"ind_56","cod_56","freas_56","pap_56","reas_56")

cat_var<-c("ind_41","cod_41","freas_41","pap_41","reas_41",
  	"ind_56","cod_56","freas_56","pap_56","reas_56")


##M0 - Baseline

m3.two_occ_irt_model<-'

#Loadings Time 1

  gf_41=~ start(1)*ind_41 +
	  L2*cod_41 +
          L3*freas_41 +
          start(1)*pap_41 +
	  start(1)*reas_41

  #Thresholds Time 1
  ind_41|t1
  cod_41|t1
  freas_41|t1
  pap_41|t1
  reas_41|t1

#Loadings Time2

  gf_56=~ start(1)*ind_56 +
	  start(.7)*cod_56 +
          start(.5)*freas_56 +
          start(.6)*pap_56 +
	  start(.8)*reas_56

  #Thresholds Time 2
  ind_56|t1
  cod_56|t1
  freas_56|t1
  pap_56|t1
  reas_56|t1

#Factor variance and covariance
gf_41~~1*gf_41
gf_56~~1*gf_56
gf_41~~gf_56

#Correlated Uniqueness
ind_41~~ind_56
cod_41~~cod_56
freas_41~~freas_56
pap_41~~pap_56
reas_41~~reas_56
'


m3.two_occ_irt_fit<-cfa(m3.two_occ_irt_model,data=brad_fluid_4156a,ordered=cat_var,
std.lv=T,link="probit",
estimator="dwls")
summary(m3.two_occ_irt_fit)