ODS GRAPHICS OFF;
ODS HTML CLOSE;
ODS LISTING;

DATA cort;
	INFILE 'C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session I - Lecture - Multiple Group Growth\Session I - Computer Scripts\Mplus - Growth Mixture\cortisol_sim.dat';
	INPUT y1-y9;
	id = _N_;
RUN;

DATA cort_long;
	SET cort;
	y = y1; time = 0; OUTPUT;
	y = y2; time = 1; OUTPUT;
	y = y3; time = 2; OUTPUT;
	y = y4; time = 3; OUTPUT;
	y = y5; time = 4; OUTPUT;
	y = y6; time = 5; OUTPUT;
	y = y7; time = 6; OUTPUT;
	y = y8; time = 7; OUTPUT;
	y = y9; time = 8; OUTPUT;

	KEEP id y time;
RUN;

GOPTIONS RESET = all;
GOPTIONS
	ftext = 'Albany AMT'
	htext = 1.8
	ctext = black;	
PROC GPLOT DATA = cort_long;
	TITLE1 ' ';
	SYMBOL1
		i=join
		r=500
		v=dot
		w=1
		h=.5
		c=black;
	AXIS1
		LABEL = (F='Albany AMT' H = 2 A=90 'Cortisol (mmol/l)')
		ORDER = (0 to 40 BY 10)
		MINOR = none
		OFFSET= (3 pct, 3 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'Time')
		ORDER = (0 to 8 BY 1)
		OFFSET= (3 PCT, 3 PCT)
		MINOR = none;
	PLOT y*time=id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;

*Plot by Grad Status;
PROC SORT;
	BY grad id ;
RUN;

PROC GPLOT DATA = wisc_long;
	TITLE1 ' ';
	SYMBOL1
		i=join
		r=500
		v=dot
		w=1
		h=.5
		c=black;
	AXIS1
		LABEL = (F='Albany AMT' H = 2 A=90 'Performance Ability')
		ORDER = (0 to 100 BY 10)
		MINOR = none
		OFFSET= (3 pct, 3 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'Grade')
		ORDER = (1 to 6 BY 1)
		OFFSET= (3 PCT, 3 PCT)
		MINOR = none;
	PLOT perf*grade=id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
	BY grad;
RUN;

PROC GPLOT DATA = wisc_long;
	TITLE1 ' ';
	SYMBOL1
		i=join
		r=158
		v=dot
		w=1
		h=.5
		c=lightgray;
	SYMBOL2
		i=join
		r=46
		v=dot
		w=1
		h=.5
		c=darkblue;
	AXIS1
		LABEL = (F='Albany AMT' H = 2 A=90 'Performance Ability')
		ORDER = (0 to 100 BY 10)
		MINOR = none
		OFFSET= (3 pct, 3 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'Grade')
		ORDER = (1 to 6 BY 1)
		OFFSET= (3 PCT, 3 PCT)
		MINOR = none;
	PLOT perf*grade=id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;


*Trajectories of Groups based on Means/Covariances/Loadings Multiple Group Growth Model;
DATA sim1;
	beta_0_g1 = 16.433;
	beta_1_g1 = 6.497;

	beta_0_g2 = 23.279;
	beta_1_g2 = 6.942;

	ARRAY A1[4] (0 1.436 3.323 5);
	ARRAY A2[4] (0 1.611 2.931 5);

	DO G = 1 to 2;
		DO t = 1 to 4;

			IF G = 1 THEN pred = beta_0_g1 + beta_1_g1 * A1[t];
			IF G = 2 THEN pred = beta_0_g2 + beta_1_g2 * A2[t];
			IF t = 1 THEN grade = 1;
			IF t = 2 THEN grade = 2;
			IF t = 3 THEN grade = 4;
			IF t = 4 THEN grade = 6;

			OUTPUT;
		END;
	END;
RUN;

PROC PRINT;
RUN;

PROC GPLOT DATA = sim1;
	SYMBOL1
		i=join
		r=1
		v=dot
		w=6
		h=.7
		c=black;
	SYMBOL2
		i=join
		r=1
		v=dot
		w=6
		h=.7
		c=red;
	AXIS1
		LABEL = (F='Albany AMT' H = 2 A=90 'Performance Ability')
		ORDER = (0 to 80 BY 20)
		MINOR = none
		OFFSET= (3 pct, 3 pct);
	AXIS2
		LABEL = (F='Albany AMT' H = 2 'Grade')
		ORDER = (1 to 6 BY 1)
		OFFSET= (3 PCT, 3 PCT)
		MINOR = none;
	PLOT pred*grade=g/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
RUN;


*Longitudinal Plots of Verbal Ability by Mother Education Groups;
DATA wisc_long;
	SET wisc;
	ID = _N_;
RUN;
DATA wisc_long1;
	SET wisc_long;
	verb = verb1; perf = perf1; grade = 1;	OUTPUT;
	verb = verb2; perf = perf2; grade = 2;	OUTPUT;
	verb = verb4; perf = perf4; grade = 4;	OUTPUT;
	verb = verb6; perf = perf6; grade = 6;	OUTPUT;
KEEP id verb perf grade moeducat;
RUN;

PROC SORT DATA = wisc_long1;
	BY moeducat;
RUN;
PROC GPLOT DATA = wisc_long1;
	SYMBOL1
		i=join
		r=500
		v=dot
		w=2
		h=.7
		l=1
		c=black;
	AXIS1
		LABEL = (F=triplex H = 2 A=90 'Verbal Ability')
		ORDER = (0 to 80 BY 10)
		MINOR = none
		OFFSET= (3 pct, 3 pct);
	AXIS2
		LABEL = (F=triplex H = 2 'Grade')
		ORDER = (1 to 6 BY 1)
		OFFSET= (3 PCT, 3 PCT)
		MINOR = none;
	PLOT verb*grade=id/NOLEGEND VAXIS= AXIS1 HAXIS=AXIS2;
	BY moeducat;
RUN;


*Multi-level Linear Growth Curve with Mother's Education as Predictor;
DATA wisc_long2;
	SET wisc_long1;
	grade_1 = grade - 1;

	IF moeducat = 1 THEN momHS = 1; ELSE momHS = 0;
	IF moeducat = 2 THEN momHSp = 1; ELSE momHSp = 0;
RUN;

PROC MIXED DATA = wisc_long2 NOCLPRINT METHOD=ML COVTEST IC;
	CLASS id;
	MODEL Verb = grade_1 momHS momHSp grade_1*momHS grade_1*momHSp / SOLUTION DDFM=BW CHISQ;
	RANDOM INTERCEPT grade_1 / SUBJECT=id TYPE=UNR;
RUN;

*Mixture Models through PROC TRAJ - Note: No within-class variation;
*Linear Growth Model;
PROC MIXED DATA = wisc_long2 NOCLPRINT METHOD=ML COVTEST;
	CLASS id;
	MODEL Verb = grade_1 / SOLUTION DDFM=BW CHISQ;
	RANDOM INTERCEPT grade_1 / SUBJECT=id TYPE=UNR;
RUN;
*Mixture Models through PROC TRAJ - Note: No within-class variation;
DATA wisc1;
	SET wisc;
	grade1 = 0; grade2 = 1; grade4 = 3; grade6 = 5;
RUN;
PROC TRAJ DATA=wisc1 OUTPLOT=OP OUTSTAT=OUTFILE OUT=OF ITDETAIL;
    ID id;
    VAR verb1 verb2 verb4 verb6;
    INDEP grade1 grade2 grade4 grade6;
	MIN 0;
	MAX 100;
    MODEL CNORM;
    NGROUPS 2;
    ORDER 1 1;
RUN;

