library(lavaan)

MG.model <- '  b_0n =~ 1*perfo1 + 1*perfo2 + 1*perfo4 + 1*perfo6
           b_1n =~ 0*perfo1 + start(1)*perfo2 + start(3)*perfo4 + 5*perfo6 

perfo1~~u*perfo1
perfo2~~u*perfo2
perfo4~~u*perfo4
perfo6~~u*perfo6'
fit <- growth(MG.model, 
           data = wisc3raw, 
           group = "grad",
           group.equal = c("intercepts", "means", "residuals", "lv.variances", "lv.covariances", "loadings"),
           mimic="mplus")
           
summary(fit, fit.measures=TRUE, standardized=TRUE)