library(lavaan)
MG.model <- '  b_0n =~ 1*perfo1 + 1*perfo2 + 1*perfo4 + 1*perfo6
           b_1n =~ 0*perfo1 + start(1)*perfo2 + start(3)*perfo4 + 5*perfo6 

perfo1~~c(u1, u2)*perfo1
perfo2~~c(u1, u2)*perfo2
perfo4~~c(u1, u2)*perfo4
perfo6~~c(u1, u2)*perfo6'

fit <- growth(MG.model, 
           data = wisc3raw, 
           group = "grad",
           mimic="mplus")
           
summary(fit, fit.measures=TRUE, standardized=TRUE)