ODS GRAPHICS OFF;
ODS HTML CLOSE;
ODS LISTING;

DATA temp1;
	INFILE 'C:\Users\kjgrimm\Documents\UCD Folder\UCD Folder\Organization\Workshops\ATI\APA-ATI LSEM 2015\Session S - Lecture - Nonlinearity\Session_4_Nonlinear_Programs\ecls_math_read_miss.dat';
	INPUT id female 
          math_fk math_sk math_f1 math_s1 math_s3 math_s5 math_s8  
          read_fk read_sk read_f1 read_s1 read_s3 read_s5 read_s8;
RUN;
DATA temp2;
	SET temp1;
	math = math_fk; read = read_fk; grade = 0.0; OUTPUT;
	math = math_sk; read = read_sk; grade = 0.5; OUTPUT;
	math = math_f1; read = read_f1; grade = 1.0; OUTPUT;
	math = math_s1; read = read_s1; grade = 1.5; OUTPUT;
	math = math_s3; read = read_s3; grade = 3.5; OUTPUT;
	math = math_s5; read = read_s5; grade = 5.5; OUTPUT;
	math = math_s8; read = read_s8; grade = 8.5; OUTPUT;

	KEEP id female grade math read;
RUN;



PROC NLMIXED DATA = temp2;
	traject = beta_0 + beta_1 * (exp(-1*(exp(-beta_2 * (grade - beta_3)))));
	MODEL math ~ NORMAL(traject, sigma2_u);
	PARMS beta_0 = -5 beta_1 = 151 beta_2 = .4 beta_3 = 1.2
          sigma2_u = 50;
RUN;
/*
                                          Fit Statistics

                             -2 Log Likelihood                 820905
                             AIC (smaller is better)           820915
                             AICC (smaller is better)          820915
                             BIC (smaller is better)           820962


                                       Parameter Estimates

                        Standard
   Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

   beta_0     -16.6691    2.0770  95E3    -8.03    <.0001    0.05  -20.7400  -12.5983  -0.00503
   beta_1       168.07    2.4091  95E3    69.77    <.0001    0.05    163.35    172.80  -0.00259
   beta_2       0.3734  0.004627  95E3    80.69    <.0001    0.05    0.3643    0.3825   -0.1344
   beta_3       0.8705   0.05479  95E3    15.89    <.0001    0.05    0.7631    0.9779  0.087904
   sigma2_u     329.09    1.5094  95E3   218.03    <.0001    0.05    326.13    332.05  5.341E-6
*/

PROC NLMIXED DATA = temp2 QPOINTS = 5;
	traject = b_0n + b_1n * (exp(-1*(exp(-beta_2 * (grade - beta_3)))));
	MODEL math ~ NORMAL(traject, sigma2_u);
	RANDOM b_0n b_1n ~ NORMAL([beta_0,beta_1],
                                  [sigma2_00,
	                               sigma_10 , sigma2_11]) SUBJECT=id;
	PARMS beta_0 = -15 beta_1 = 170 beta_2 = .4 beta_3 = 1
	      sigma2_00 = 100 sigma2_11 = 425 
          sigma_10 = 0
          sigma2_u = 50;
RUN;

/*
                                         Fit Statistics

                             -2 Log Likelihood                 733854
                             AIC (smaller is better)           733870
                             AICC (smaller is better)          733870
                             BIC (smaller is better)           733933


                                       Parameter Estimates

                        Standard
   Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

   beta_0      -9.1092    0.7376  21E3   -12.35    <.0001    0.05  -10.5549   -7.6635  0.092693
   beta_1       153.33    0.8808  21E3   174.08    <.0001    0.05    151.60    155.05  0.006948
   beta_2       0.4125  0.002130  21E3   193.70    <.0001    0.05    0.4083    0.4167  -13.9025
   beta_3       0.9760   0.01976  21E3    49.38    <.0001    0.05    0.9373    1.0147  -1.21344
   sigma2_00   63.0239    1.4554  21E3    43.30    <.0001    0.05   60.1712   65.8766  -0.00423
   sigma2_11    765.10   14.3983  21E3    53.14    <.0001    0.05    736.88    793.33  0.000394
   sigma_10   -30.8047    4.8852  21E3    -6.31    <.0001    0.05  -40.3800  -21.2294  -0.00378
   sigma2_u    65.9624    0.3849  21E3   171.38    <.0001    0.05   65.2079   66.7168  0.003736
*/


PROC NLMIXED DATA = temp2 QPOINTS = 5;
	traject = b_0n + b_1n * (exp(-1*(exp(-beta_2 * (grade - beta_3)))));
	MODEL math ~ NORMAL(traject, sigma2_u);
	RANDOM b_0n b_1n ~ NORMAL([beta_0,beta_1],
                                  [sigma2_00,
	                               sigma_10 , sigma2_11]) SUBJECT=id;
	PARMS beta_0 = -15 beta_1 = 170 beta_2 = .4 beta_3 = 1
	      sigma2_00 = 100 sigma2_11 = 425 
          sigma_10 = 0
          sigma2_u = 50;
RUN;

/* No Convergence */

PROC NLMIXED DATA = temp2 METHOD = FIRO;
	traject = beta_0 + b_1n * (exp(-1*(exp(-b_2n * (grade - b_3n)))));
	MODEL math ~ NORMAL(traject, sigma2_u);
	RANDOM b_1n b_2n b_3n ~ NORMAL([beta_1,beta_2,beta_3],
                                           [sigma2_11,
	                                        sigma_21 , sigma2_22,
											sigma_31 , sigma_32 , sigma2_33]) SUBJECT=id;
	PARMS beta_0 = -7  beta_1 = 152 beta_2 = .4 beta_3 = 1
	      sigma2_11 = 425 sigma2_22 = .002 sigma2_33 = .05
          sigma_21 = 0 sigma_31 = 0 sigma_32 = 0
          sigma2_u = 50;
RUN;
 
/*

                                          Fit Statistics

                             -2 Log Likelihood                 722392
                             AIC (smaller is better)           722414
                             AICC (smaller is better)          722414
                             BIC (smaller is better)           722501


                                       Parameter Estimates

                        Standard
   Parameter  Estimate     Error    DF  t Value  Pr > |t|   Alpha     Lower     Upper  Gradient

   beta_0      -6.3094    0.5959  21E3   -10.59    <.0001    0.05   -7.4774   -5.1413  -1.95852
   beta_1       152.72    0.7375  21E3   207.07    <.0001    0.05    151.27    154.16  -3.89952
   beta_2       0.4039  0.001987  21E3   203.23    <.0001    0.05    0.4000    0.4078  -9.55853
   beta_3       1.1085   0.01682  21E3    65.89    <.0001    0.05    1.0755    1.1415  2.651651
   sigma2_11    425.01    8.0008  21E3    53.12    <.0001    0.05    409.33    440.69  -0.03416
   sigma2_22  0.008135  0.000182  21E3    44.73    <.0001    0.05  0.007779  0.008492  -45.4717
   sigma2_33    0.2532  0.005050  21E3    50.14    <.0001    0.05    0.2433    0.2631  -9.73297
   sigma_21     0.5172   0.02740  21E3    18.88    <.0001    0.05    0.4635    0.5709  1.076959
   sigma_31    -0.7007    0.1601  21E3    -4.38    <.0001    0.05   -1.0145   -0.3869  -4.52716
   sigma_32   -0.03722  0.000746  21E3   -49.92    <.0001    0.05  -0.03868  -0.03575  -36.0589
   sigma2_u    49.9706    0.3264  21E3   153.10    <.0001    0.05   49.3308   50.6103   -0.0705
*/

PROC NLMIXED DATA = temp2 QPOINTS = 1;
	traject = beta_0 + b_1n * (exp(-1*(exp(b_2n * (grade - b_3n)))));
	MODEL math ~ NORMAL(traject, sigma2_u);
	RANDOM b_1n b_2n b_3n ~ NORMAL([beta_1,beta_2,beta_3],
                                           [sigma2_11,
	                                        sigma_21 , sigma2_22,
											sigma_31 , sigma_32 , sigma2_33]) SUBJECT=id;
	PARMS beta_0 = -4 beta_1 = 155 beta_2 = .4 beta_3 = 1
	      sigma2_11 = 430 sigma2_22 = .01 sigma2_33 = .1
          sigma_21 = 0 sigma_31 = 0 sigma_32 = 0
          sigma2_u = 60;
RUN;

