#read in data
ecls.1 = read.table('C:\\Users\\kjgrimm\\Documents\\UCD\\Organization\\Workshops\\ATI\\APA-ATI LSEM 2015\\Session S - Lecture - Nonlinearity\\Session S - Programming Scripts\\ecls_math_read_miss.dat', na.strings = '.')

names(ecls.1) = c('id','female',
                  'math_fk','math_sk','math_f1','math_s1','math_s3','math_s5','math_s8',  
                  'read_fk','read_sk','read_f1','read_s1','read_s3','read_s5','read_s8')

#reshaping the data
ecls.2 = reshape(ecls.1, 
            varying = c("math_fk","math_sk","math_f1","math_s1","math_s3","math_s5","math_s8"), 
            v.names = "score",
            timevar = "grade", 
            times = c(0,0.5,1,1.5,3.5,5.5,8.5), 
            direction = "long")

ecls.2 = ecls.2[order(ecls.2$id),]

View(ecls.2)

library(ggplot2)

plot_obs <- ggplot(data=ecls.2, aes(x=grade, y=score, group=id)) +
                 geom_line() +
                 theme_bw()

print(plot_obs)


#nlme
#install.packages("nlme")
library(nlme)

# Lower & Upper Asymptotes are Random
fit.nlme1 = nlme(score~b_0n + b_1n * (exp(-1*(exp(-beta_2 * (grade - beta_3))))),
                 data=ecls.2,
                 fixed=b_0n+b_1n+beta_2+beta_3~1,
                 random=b_0n+b_1n~1,
                 groups= ~id,
                 start=c(-7, 154, .4, 1),
                 na.action=na.omit)

summary(fit.nlme1)

#Nonlinear mixed-effects model fit by maximum likelihood
#  Model: score ~ b_0n + b_1n * (exp(-1 * (exp(-beta_2 * (grade - beta_3))))) 
# Data: ecls.2 
#       AIC      BIC    logLik
#  734015.4 734091.1 -366999.7
#
#Random effects:
# Formula: list(b_0n ~ 1, b_1n ~ 1)
# Level: id
# Structure: General positive-definite, Log-Cholesky parametrization
#         StdDev    Corr  
#b_0n      7.919328 b_0n
#b_1n     27.762256 -0.169
#Residual  8.132559       
#
#Fixed effects: b_0n + b_1n + beta_2 + beta_3 ~ 1 
#           Value Std.Error    DF   t-value p-value
#b_0n   -10.35358 0.4578685 74028 -22.61256       0
#b_1n   153.33139 0.5831263 74028 262.94713       0
#beta_2   0.41955 0.0014634 74028 286.70223       0
#beta_3   0.91583 0.0119405 74028  76.69899       0
# Correlation: 
#       b_0n   b_1n   beta_2
#b_1n   -0.909              
#beta_2  0.793 -0.829       
#beta_3  0.966 -0.834  0.690
#
#Standardized Within-Group Residuals:
#        Min          Q1         Med          Q3         Max 
#-6.18474986 -0.50355883 -0.01759176  0.46435572  6.29562804 
#
#Number of Observations: 95076
#Number of Groups: 21045 


