##########################################

### Time-Varying Covariate Growth Model 1 

data<-read.table("nlsy_ach_bpi1.dat",header=F,colClasses="numeric",
na.string=".")

#paste command - pattern to name columns
#paste0 = paste command with no separation
#paste0("tot",4:14) = "tot4","tot5",..."tot14"

names(data)<-c("id","race","sex","m_birth","ldisabil", 
	paste0("dep",4:14),paste0("tot",4:14),
	paste0("anti",4:14),paste0("axdp",4:14),
	paste0("math",5:14),paste0("rec",5:14),
	paste0("comp",4:14),paste0("pvt",4:14))

t<-which(data$ldisabil==1)
data<-data[-t,]
#access data columns easily by attaching it
attach(data)



##Define variables

    data$total8  = (((dep8  + anti8  + axdp8)-5.039)/4.076)*10+50;
    data$total9  = (((dep9  + anti9  + axdp9)-5.039)/4.076)*10+50;
    data$total10 = (((dep10 + anti10 + axdp10)-5.039)/4.076)*10+50;
    data$total11 = (((dep11 + anti11 + axdp11)-5.039)/4.076)*10+50;
    data$total12 = (((dep12 + anti12 + axdp12)-5.039)/4.076)*10+50;
    data$total13 = (((dep13 + anti13 + axdp13)-5.039)/4.076)*10+50;
    data$total14 = (((dep14 + anti14 + axdp14)-5.039)/4.076)*10+50;
##Define variables

    data$pvt8 = ((pvt8-82.130)/16.745)*10+50;
    data$pvt9 = ((pvt9-82.130)/16.745)*10+50;
    data$pvt10 = ((pvt10-82.130)/16.745)*10+50;
    data$pvt11 = ((pvt11-82.130)/16.745)*10+50;
    data$pvt12 = ((pvt12-82.130)/16.745)*10+50;
    data$pvt13 = ((pvt13-82.130)/16.745)*10+50;
    data$pvt14 = ((pvt14-82.130)/16.745)*10+50;
biv_tvc1<-'

#####
#PVT#
#####

##Level 

b_0n =~ 1*pvt8+1*pvt9+1*pvt10+1*pvt11+1*pvt12+1*pvt13+1*pvt14
b_0n ~ start(50)*1
b_0n ~~ start(70)*b_0n

## SLOPE - Growth

b_1n =~ 0*pvt8+start(.2)*pvt9+start(.4)*pvt10+start(.6)*pvt11+
start(.8)*pvt12+start(.9)*pvt13+1*pvt14
b_1n~start(11.507)*1
b_1n~~start(2.184)*b_1n
b_1n~~start(10.752)*b_0n

#Means of PVT to zero
pvt8+pvt9+pvt10+pvt11+pvt12+pvt13+pvt14~0*1

#Specific Variances

pvt8~~sigma2_s*pvt8
pvt9~~sigma2_s*pvt9
pvt10~~sigma2_s*pvt10
pvt11~~sigma2_s*pvt11
pvt12~~sigma2_s*pvt12
pvt13~~sigma2_s*pvt13
pvt14~~sigma2_s*pvt14


#intercept for total
total8+total9+total10+total11+total12+total13+total14~1

##saturate behavior with covariances
total8~~total9
total8~~total10
total8~~total11
total8~~total12
total8~~total13
total8~~total14
total9~~total10
total9~~total11
total9~~total12
total9~~total13
total9~~total14
total10~~total11
total10~~total12
total10~~total13
total10~~total14
total11~~total12
total11~~total13
total11~~total14
total12~~total13
total12~~total14
total13~~total14


##variances 
total8~~total8
total9~~total9
total10~~total10
total11~~total11
total12~~total12
total13~~total13
total14~~total14

##covariance with factors
b_0n~~total8
b_0n~~total9
b_0n~~total10
b_0n~~total11
b_0n~~total12
b_0n~~total13
b_0n~~total14

b_1n~~total8
b_1n~~total9
b_1n~~total10
b_1n~~total11
b_1n~~total12
b_1n~~total13
b_1n~~total14

#Regressions
pvt8~gamma*total8
pvt9~gamma*total9
pvt10~gamma*total10
pvt11~gamma*total11
pvt12~gamma*total12
pvt13~gamma*total13
pvt14~gamma*total14

'

tvc1_fit<-lavaan(biv_tvc1,data=data,missing='ML',fixed.x=F)
